# 1 "pxws_io.c"
 























 
 








# 1 "/usr/local/include/stdio.h" 1 3
 
 


























 



























































# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 89 "/usr/local/include/stdio.h" 2 3



typedef unsigned int	size_t;		 









			 




extern	struct	_iobuf {
	int	_cnt;
	char	*_ptr;
	char	*_base;
	int	_bufsiz;
	short	_flag;
	short	_file;
} _iob[3 ];
typedef	struct _iobuf	FILE;

typedef	long	fpos_t;

















 









 



extern int 	getc( FILE *__stream );
extern int	getchar( void );
extern int	putc( int __c, FILE *__stream);
extern int	putchar( int __c);
extern int	feof( FILE *__stream );
extern int	ferror( FILE *__stream );
extern int	fileno( FILE *__stream );
extern int	_filbuf( FILE *p);
extern int	_flsbuf( unsigned char x , FILE *p);
















typedef char *va_list;

 



extern void	clearerr( FILE *__stream); 
extern int	fclose( FILE *__stream );
extern FILE *	fdopen( int __filedes, char *__type );
extern int	fflush( FILE *__stream );
extern int	fgetc( FILE *__stream );
extern int	fgetpos( FILE *__stream, fpos_t *__pos );
extern char *	fgets( char *__s, int __n, FILE *__stream );
extern FILE *	fopen( const char *__filename, const char *__type );
extern int	fprintf( FILE *__stream, const char *__format, ... );
extern int	fputc( int __c, FILE *__stream );
extern int	fputs( const char *__s, FILE *__stream );
extern size_t	fread( void *__ptr, size_t __size,
			size_t __nitems, FILE *__stream ); 
extern FILE *	freopen( const char *__filename, const char *__type,
			FILE *__stream );
extern int	fscanf( FILE *__stream, const char *__format, ... );
extern int	fseek( FILE *__stream, long __offset, int __ptrname );
extern int	fsetpos( FILE *__stream, const fpos_t *__pos );
extern long	ftell( FILE *__stream );
extern size_t	fwrite( const void *__ptr, size_t __size,
			size_t __nitems, FILE *__stream );
extern char *	gets( char *__s );	
extern void	perror( const char *__s );
extern FILE  *	popen(const char *__command, const char *__type );
extern int	printf( const char *__format, ... );	
extern int	puts( const char *__s );	
extern int	remove( const char *__filename );
extern int	rename( const char *__from, const char *__to );
extern void	rewind( FILE *__stream );
extern int	scanf( const char *__format, ... );	
extern void	setbuf( FILE *__stream, char *__buf );
extern int	setvbuf( FILE *__stream, char *__buf,
			int __type, size_t __size );
extern int	sscanf( const char *__s, const char *__format, ... );
extern FILE *	tmpfile( void );	
extern char *	tmpnam( char *__s );
extern int	ungetc( int __c, FILE *__stream );
extern int	vfprintf( FILE *__stream, const char *__format, va_list __ap );
extern int	vprintf( const char *__format, va_list __ap );
extern int	vsprintf( char *__s, const char *__format, va_list __ap);


extern char *	tempnam( const char *__dir, const char *__pfx);
extern int	putw( int __w, FILE *__stream );
extern int	getw(FILE *__stream);
extern int	pclose( FILE *__stream );


# 300 "/usr/local/include/stdio.h" 3



 
extern int	sprintf( char *__s, const char *__format, ... );



















# 35 "pxws_io.c" 2


# 1 "pxws.h" 1


# 1 "/usr/include/io/ws/pa.h" 1 3
 


 























 













 

































# 104 "/usr/include/io/ws/pa.h" 3



# 117 "/usr/include/io/ws/pa.h" 3

 













 






 




















# 169 "/usr/include/io/ws/pa.h" 3


 







typedef struct _stic_cmd {
        unsigned Op                     :4;
        unsigned RGBMode                :2;
        unsigned ZMode                  :2;
        unsigned XYMask                 :2;
        unsigned LineWidthPer           :2;
        unsigned Reserved0              :7;
        unsigned ClipRect               :1;
        unsigned Reserved1              :1;
        unsigned Mesh                   :1;
        unsigned Reserved2              :1;
        unsigned AALine                 :1;
        unsigned Reserved3              :7;
        unsigned HSEquals               :1;
} sticCmd;

typedef struct {
    unsigned long minval;
    unsigned long maxval;
} pa_StampClipRect;

typedef struct {
        long		 numClipRects;
        long		 refCount;
        pa_StampClipRect clipRects[      8 ];
} pa_ClipList;













 
typedef struct _pa_Packet {
     union {
	struct {
	    long opcode;
	} un;
	struct {
	    long opcode;
	    long word_count;
	    long cliplist_sync;
	    long data[1];
	} PassPacket;
	struct {
	    long opcode;
	    long word_count;
	    long sram_phys_addr;
	    long r3000_virt_addr;
	} ReadSram;
	struct {
	    long opcode;
	    long word_count;
	    long sram_phys_addr;
	    long r3000_virt_addr;
	} WriteSram;
	struct {
	    long opcode;
	    long sram_phys_addr;
	    long data;
	} PutData;
	struct {
	    long opcode;
	    long cliplist_number;
	    long cliprect_count;
	    pa_StampClipRect rect[1];
	} LoadClipList;
     } un;
} pa_Packet, *pa_PacketPtr;


typedef struct _Com2d {
    long pad1[3];			 
    long NoOp[10];			 
    long Stic_NoOp[10];			 
    long Video_NoOp[4];			 
    volatile long intr_status;		 
    volatile long lastRead;
    volatile long lastWritten;
    volatile long qDepth;
    pa_StampClipRect *pCliprect;
    long numCliprect;
    pa_StampClipRect *fixCliprect;
    volatile long *srv_qpoll[16 ];
    volatile long *intr_qpoll[16 ];
    volatile long *save_region[16 ];
} pa_Com2d, *pa_Com2dPtr;


typedef struct _pa_ComArea {

	 
	long CmdBuf0[ (1 * 		(0x1000) )  >> 2 ];
	long CmdBuf1[ (1 * 		(0x1000) )  >> 2 ];

	 
	long image_buf[ ((3 * 		(0x1000) ) +4) >> 2 ];

	 
	long SRVCom[ ((	(		(0x1000)  >> 1) ) -4) >> 2 ];

	 
	pa_Com2d SRV2DCom;
	char pad1[	(	(		(0x1000)  >> 1) )  - sizeof(pa_Com2d)];

	 
	pa_ClipList ClipL[      16  ];
	char pad2[(2 * 		(0x1000) ) -sizeof(pa_ClipList)*     16 ];

	 
	long IntrBuf[16 ][(1 * 		(0x1000) )  >> 2];

} pa_ComArea, *pa_ComAreaPtr;

# 309 "/usr/include/io/ws/pa.h" 3


# 3 "pxws.h" 2

# 1 "/usr/include/io/ws/px.h" 1 3
 


 























 

















# 1 "/usr/include/sys/param.h" 1 3
 

 



























 















































































 

 







# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 121 "/usr/include/sys/param.h" 2 3

# 1 "/usr/include/machine/param.h" 1 3
 



 



























 
 
 
 
 
 
 

 


































 



 






























 


 



 




 


 


 




extern unsigned int sr_usermask;



 









# 122 "/usr/include/sys/param.h" 2 3








 







 





# 164 "/usr/include/sys/param.h" 3
















 




 






				 
				 
				 
				 

 



 






















 















 


 






# 1 "/usr/include/signal.h" 1 3
 

 


























 











































# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 74 "/usr/include/signal.h" 2 3


















					 
 



















 







































 







 


















 

typedef long	sig_atomic_t;
typedef int sigset_t;	 


 


struct	sigvec {
	void	 (*sv_handler)();	 
	sigset_t sv_mask;		 
	int	sv_flags;		 
};


 



struct	sigaction {
	void	 (*sa_handler)();	 
	sigset_t sa_mask;		 
	int	 sa_flags;		 
};














 







 


struct	sigstack {
	char	*ss_sp;			 
	int	ss_onstack;		 
};

 















struct	sigcontext {

	 




	int	sc_onstack;		 
	int	sc_mask;		 






	int	sc_pc;			 
	 


	int	sc_regs[32];	 
	int	sc_mdlo;	 
	int	sc_mdhi;	 
	 


	int	sc_ownedfp;	 
	int	sc_fpregs[32];	 
	int	sc_fpc_csr;	 
	int	sc_fpc_eir;	 
	 



	 


	int	sc_cause;	 
	int	sc_badvaddr;	 
	int	sc_badpaddr;	 

};





















typedef int pid_t;

 



extern void	(*signal(int __sig, void(*__func)(int)))(int);
int	raise( int __sig );
int 	kill( pid_t __pid, int __sig );
int 	sigemptyset( sigset_t *__set );
int 	sigfillset( sigset_t *__set );
int 	sigaddset( sigset_t *__set, int __signo );
int	sigdelset( sigset_t *__set, int __signo );
int	sigismember( const sigset_t *__set, int __signo );
int 	sigaction( int __sig, const struct sigaction *__act,
		struct sigaction *__oact );
int 	sigprocmask( int __how, const sigset_t *__set, sigset_t *__oset );
int	sigpending( sigset_t *__set );
int	sigsuspend( const sigset_t *__sigmask );











 









# 250 "/usr/include/sys/param.h" 2 3








 






 




 

























 








# 1 "/usr/include/sys/types.h" 1 3
 

 



























 















































# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 79 "/usr/include/sys/types.h" 2 3




 



 


 


 


typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned int	uint;		 
typedef	unsigned long	u_long;
typedef	unsigned short	ushort;		 

typedef	volatile char		v_char;
typedef	volatile short		v_short;
typedef	volatile long		v_long;
typedef	volatile unsigned char	vu_char;
typedef	volatile unsigned short	vu_short;
typedef	volatile unsigned long	vu_long;

typedef

	signed

		char	s_char;









typedef	struct	_physadr { int r[1]; } *physadr;
 



typedef	struct	label_t	{
	int	val[12];
} label_t;


typedef	struct	_quad { long val[2]; } quad;
typedef	long	daddr_t;
typedef	char *	caddr_t;
typedef u_long	gno_t;
typedef short	cnt_t;			 
typedef	long	swblk_t;
typedef long	paddr_t;		 
typedef	long	audit_ID_t;


typedef	short	dev_t;
typedef short	gid_t;			 
typedef	unsigned long	ino_t;
typedef unsigned short	mode_t;		 
typedef short	nlink_t;		 
typedef	int	off_t;




typedef short	uid_t;			 


typedef int	time_t;









typedef int	clock_t;			 

typedef long	key_t;			 




 











 









 

typedef long	fd_mask;






typedef	struct fd_set {
	fd_mask	fds_bits[(((4096	 )+(( (sizeof(fd_mask) * 8		)	)-1))/( (sizeof(fd_mask) * 8		)	)) ];
} fd_set;








# 305 "/usr/include/sys/param.h" 2 3








# 1 "/usr/include/sys/smp_lock.h" 1 3
 

 



























 





















































































 








# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 126 "/usr/include/sys/smp_lock.h" 2 3










 

















 



struct __lock_t {
	volatile unsigned int
			l_call:8,	 
			l_hierpos:8,	 
			l_ipl:8,	 
			l_type:7,	 
			l_lock:1;	 
	struct __lock_t	*l_plock;	 
	char *		l_pc;
	unsigned long 	l_lost; 	 
	unsigned long 	l_spin;		 
	unsigned long 	l_won;		 
	unsigned short 	l_wanted;	 

};




 



struct lock_trace {
	long tr_pid;	 
	caddr_t tr_pc;	 
	long tr_psl;	 
	struct __lock_t  *tr_lock;	 
};



struct debug_entry {
		unsigned int spinct;
		caddr_t calling_pc;
		caddr_t holding_pc;
	};
struct debug_lock_trace {
	struct __lock_t  *traced_lock;
	int current_lock_trace;	
	int debug_lock_entries;
	struct debug_entry element[200 ];
};

extern struct debug_lock_trace *debug_lock_trace;

 
struct lock_data {
	char	l_hierpos;
	char	l_type;
	char	l_ipl;
};

# 384 "/usr/include/sys/smp_lock.h" 3




# 313 "/usr/include/sys/param.h" 2 3







 






























 







 












 





 







 





 





# 46 "/usr/include/io/ws/px.h" 2 3

# 1 "/usr/include/sys/ioctl.h" 1 3

 



 



























 




















































































































































# 191 "/usr/include/sys/ioctl.h" 3

# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 192 "/usr/include/sys/ioctl.h" 2 3



# 1 "/usr/include/sys/ttychars.h" 1 3
 

 


























 










 





struct ttychars {
	char	tc_erase;	 
	char	tc_kill;	 
	char	tc_intrc;	 
	char	tc_quitc;	 
	char	tc_startc;	 
	char	tc_stopc;	 
	char	tc_eofc;	 
	char	tc_brkc;	 
	char	tc_suspc;	 
	char	tc_dsuspc;	 
	char	tc_rprntc;	 
	char	tc_flushc;	 
	char	tc_werasc;	 
	char	tc_lnextc;	 
};



 




















# 195 "/usr/include/sys/ioctl.h" 2 3


# 1 "/usr/include/sys/ttydev.h" 1 3
 

 



























 







 





 



















# 80 "/usr/include/sys/ttydev.h" 3


# 197 "/usr/include/sys/ioctl.h" 2 3



# 1 "/usr/include/sys/ttyio.h" 1 3

 



 



























 






























 
struct tchars {
	char	t_intrc;		 
	char	t_quitc;		 
	char	t_startc;		 
	char	t_stopc;		 
	char	t_eofc; 		 
	char	t_brkc; 		 
};

 
struct ltchars {
	char	t_suspc;		 
	char	t_dsuspc;		 
	char	t_rprntc;		 
	char	t_flushc;		 
	char	t_werasc;		 
	char	t_lnextc;		 
};

 
struct winsize {
	unsigned short	ws_row, ws_col; 	 
	unsigned short	ws_xpixel, ws_ypixel;	 
};



# 200 "/usr/include/sys/ioctl.h" 2 3




# 1 "/usr/include/sgtty.h" 1 3
 




 


























 








 











# 1 "/usr/include/ansi_compat.h" 1 3
 



 





















 

















# 116 "/usr/include/ansi_compat.h" 3

# 54 "/usr/include/sgtty.h" 2 3




 





# 76 "/usr/include/sgtty.h" 3

 



struct sgttyb  {
	char	sg_ispeed;		 
	char	sg_ospeed;		 
	char	sg_erase;		 
	char	sg_kill;		 
	short	sg_flags;		 
};






# 204 "/usr/include/sys/ioctl.h" 2 3






 




















 



























 


























































 




































































						 


















					 


 













 















































 
 
 


 




 









 



 






 



 





 




 





typedef struct X29PARAMS
{
  unsigned char x29_len;
  unsigned char x29_data[ 127  - 1];		 
} x29params;




 
















# 47 "/usr/include/io/ws/px.h" 2 3






 


typedef struct _stic_regs {
    int __pad0;			 
    int __pad1;			 
    int	hsync;			 
    int	hsync2;			 
    int	hblank;			 
    int	vsync;			 
    int	vblank;			 
    int	vtest;			 
    int	ipdvint;		 
    int	__pad2;			 
    int	sticsr;			 
    int	busdat;			 
    int	busadr;			 
    int	__pad3;			 
    int	buscsr;			 
    int	modcl;			 
} stic_regs;

typedef struct _stic_csr {
    unsigned tstfnc : 2;
    unsigned checkpar : 1;
    unsigned startvt : 1;
    unsigned start : 1;
    unsigned reset : 1;
    unsigned autoread : 1;
    unsigned startst : 1;
    unsigned : 24;
} stic_csr;

 













typedef struct _stic_intr {
    unsigned	eint_en : 1;	      
    unsigned	eint : 1;	      
    unsigned	eint_mask : 1;	      
    unsigned	: 5;
    unsigned	vint_en : 1;	      
    unsigned	vint : 1;	      
    unsigned	vint_mask : 1;	      
    unsigned	: 5;
    unsigned	pint : 1;	      
    unsigned	pint_en : 1;	      
    unsigned	pint_mask : 1;	      
} stic_intr;

 














typedef struct _stic_cf {
    unsigned	: 8;
    unsigned	vdac : 1;
    unsigned	yconfig : 2;
    unsigned	xconfig : 1;
    unsigned	option : 3;
    unsigned	: 9;
    unsigned	revision : 8;
} stic_cf;


 









 





 





























 




 




 


 




 





typedef struct _painfo {
    int *pxo;
    int *stic_dma_rb;
    stic_regs *stic_regs;
} paInfo;

typedef struct _pqinfo {
    int  *pxo;			 
    int  *ram;			 
    int   ptpt_phys;		 
    int   ptpt_size;
    int  *pgin_vaddr;
    short pgin_pages;		 
    short pgin_dirty;		 
    int   ram_size;		 
} pqInfo;

typedef struct _pxinfo {
    short	stamp_width;
    short	stamp_height;
    short	n10_present;		 
    char	zplanes;		 
    char	xplanes;		 
    int		rb_size;		 
    int		rb_phys;		 
    int *	rb_addr;		 
    int		ib_size;		 
    int		idle_count;		 
    int		idle_sample;		 
    union {
	paInfo	pa;
	pqInfo	pq;
    } dev;
} pxInfo;






 


typedef struct {
    short         screen;
    short         cmd;
    unsigned long data;
} px_ioc;










# 4 "pxws.h" 2

# 1 "/usr/include/io/ws/stamp.h" 1 3
 


 




















 











typedef struct _stamp_cmd {
    unsigned opcode : 4;		 







    unsigned rgb_format : 2;		 




    unsigned z_format : 2;		 




    unsigned xymask_format : 2;		 



    unsigned linewidth_format : 2;	 




    unsigned : 7;			 
    unsigned cliprect : 1;		 
    unsigned : 1;			 
    unsigned mesh : 1;			 
    unsigned : 1;			 
    unsigned aa_line : 1;		 
    unsigned : 7;			 
    unsigned hs_equals : 1;		 
} stampCmd;


		 










		 







		 







		 






		 






		 




		 




		 




		 





typedef struct _stamp_zcount {
    unsigned mask : 24;
    unsigned count : 8;
} stampZCount;




typedef struct _stamp_update {
    unsigned enable : 1;		 
    unsigned read_buff : 2;		 
    unsigned write_buff : 2;		 
    unsigned plane : 1;			 


    unsigned save_sign : 1;		 
    unsigned save_alpha : 1;		 
    unsigned make_we : 3;		 




    unsigned supersample : 1;		 
    unsigned umet : 7;			 



















    unsigned span : 1;			 
    unsigned aligned : 1;		 
    unsigned minmax : 1;		 
    unsigned mult : 1;			 
    unsigned multacc : 1;		 
    unsigned : 3;			 
    unsigned halfbuff : 1;		 
    unsigned dblbuff : 3;		 




    unsigned init : 1;			 
} stampUpdate;


		 




		 







		 







		 





		 




		 




		 






		 




		 



















         





		 




		 




		 




		 




		 




		 




		 


		       

		       




		 





 









typedef short stampXYMask[16];











 


























# 5 "pxws.h" 2


extern pxInfo *px_info_ptr;
extern pa_ComAreaPtr rb_cntrl;
extern pa_Com2dPtr rb_com2d;

extern int px_info_max_x;
extern int px_info_max_y;



# 37 "pxws_io.c" 2


# 1 "../../../.././X11/X.h" 1
 



 




 

























 

typedef unsigned long XID;

typedef XID Window;
typedef XID Drawable;
typedef XID Font;
typedef XID Pixmap;
typedef XID Cursor;
typedef XID Colormap;
typedef XID GContext;
typedef XID KeySym;

typedef unsigned long Mask;

typedef unsigned long Atom;

typedef unsigned long VisualID;

typedef unsigned long Time;

typedef unsigned char KeyCode;

 






























 



 





























 







































 











 












 











 









 







		       
 










 





 




 





 




 




 




 







 










 





 














# 311 "../../../.././X11/X.h"











 



 
 




 

















 










 













 



 





 





 




 





 







 




 





 



 


















 





 






 





 






 




 




 






 




 





 




 



























 



 






 



 





 



 





 





 



 





 










 


















 














 




 



 




 




 











 





# 39 "pxws_io.c" 2

# 1 "../../../include/misc.h" 1
 






















 


 





extern unsigned long globalSerialNumber;
extern unsigned long serverGeneration;

# 1 "../../../.././X11/Xosdefs.h" 1
 



























 












































  





















# 36 "../../../include/misc.h" 2















typedef unsigned char *pointer;
typedef int Bool;
typedef unsigned long PIXEL;
typedef unsigned long ATOM;






# 1 "../../../include/os.h" 1
 























 



# 1 "../../../include/misc.h" 1
 






















 
# 157 "../../../include/misc.h"

# 29 "../../../include/os.h" 2
















typedef pointer	FID;
typedef struct _FontPathRec *FontPathPtr;
typedef struct _NewClientRec *NewClientPtr;


 




# 68 "../../../include/os.h"







 





 
























# 1 "/usr/local/include/string.h" 1 3
 



 


























 

















 







 




extern char
	*strcat( char *__s1, const char *__s2 ),	
	*strchr( const char *__s, int __c ),
	*strcpy( char *__s1, const char *__s2 ),
	*strerror( int __n ),		
	*strncat( char *__s1, const char *__s2, size_t __n ),
	*strncpy( char *__s1, const char *__s2, size_t __n ),
	*strpbrk(const char *__s1, const char *__s2 ),	
	*strrchr( const char *__s, int __c ),
	*strstr( const char *__s, const char *__t ),
	*strtok( char *__s1, const char *__s2 );	

extern int
	memcmp( const void *__s1, const void *__s2, size_t __n ),
	strcmp( const char *__s1, const char *__s2 ),
	strcoll( const char *__s1, const char *__s2 ),
	strncmp( const char *__s1, const char *__s2, size_t __n );

extern void
	*memchr( const void *__s, int __c, size_t __n ),	
	*memcpy( void *__s1, const void *__s2, size_t __n ),
	*memmove( void *__s1, const void *__s2, size_t __n ),
	*memset( void *__s, int __c, size_t __n );

extern size_t
	strcspn( const char *__s1, const char *__s2 ),
	strlen( const char *__s ),
	strspn( const char *__s1, const char *__s2 ),
	strxfrm( char *__to, const char *__from, size_t __maxsize  );

# 126 "/usr/local/include/string.h" 3

# 106 "../../../include/os.h" 2









int		ReadRequestFromClient();
Bool		CloseDownConnection();
FontPathPtr	ExpandFontNamePattern();
FID		FiOpenForRead();
void		CreateWellKnownSockets();
int		SetDefaultFontPath();
void		FreeFontRecord();
int		SetFontPath();
void		ErrorF();
void		Error();
void		FatalError();
void		ProcessCommandLine();
void		Xfree();
void		FlushAllOutput();
void		FlushIfCriticalOutputPending();
unsigned long	*Xalloc();
unsigned long	*Xrealloc();
long		GetTimeInMillis();


# 61 "../../../include/misc.h" 2

# 1 "../../../.././X11/Xfuncs.h" 1
 



























# 1 "/usr/local/include/string.h" 1 3
 



 


























 

















 







 




extern char
	*strcat( char *__s1, const char *__s2 ),	
	*strchr( const char *__s, int __c ),
	*strcpy( char *__s1, const char *__s2 ),
	*strerror( int __n ),		
	*strncat( char *__s1, const char *__s2, size_t __n ),
	*strncpy( char *__s1, const char *__s2, size_t __n ),
	*strpbrk(const char *__s1, const char *__s2 ),	
	*strrchr( const char *__s, int __c ),
	*strstr( const char *__s, const char *__t ),
	*strtok( char *__s1, const char *__s2 );	

extern int
	memcmp( const void *__s1, const void *__s2, size_t __n ),
	strcmp( const char *__s1, const char *__s2 ),
	strcoll( const char *__s1, const char *__s2 ),
	strncmp( const char *__s1, const char *__s2, size_t __n );

extern void
	*memchr( const void *__s, int __c, size_t __n ),	
	*memcpy( void *__s1, const void *__s2, size_t __n ),
	*memmove( void *__s1, const void *__s2, size_t __n ),
	*memset( void *__s, int __c, size_t __n );

extern size_t
	strcspn( const char *__s1, const char *__s2 ),
	strlen( const char *__s ),
	strspn( const char *__s1, const char *__s2 ),
	strxfrm( char *__to, const char *__from, size_t __maxsize  );

# 126 "/usr/local/include/string.h" 3

# 29 "../../../.././X11/Xfuncs.h" 2




# 52 "../../../.././X11/Xfuncs.h"




# 62 "../../../include/misc.h" 2






     







 





 











 

 












 
















 







 




 






 




extern void SwapLongs();
extern void SwapShorts();

typedef struct _DDXPoint *DDXPointPtr;
typedef struct _Box *BoxPtr;


# 40 "pxws_io.c" 2


extern pxInfo *px_info_ptr;
extern pa_ComAreaPtr rb_cntrl;
extern pa_Com2dPtr rb_com2d;

extern int px_info_max_x;
extern int px_info_max_y;

ga_send_packet()
{
  int nbuf;
  int gaintr;
  int i;
  
  for(i = 0; rb_com2d->intr_status != 0; i++);
  
 



  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return 0 ;
    }
  if(nbuf != 16 -1)
      rb_com2d->lastWritten++;
  else
      rb_com2d->lastWritten = 0;
  
  if(rb_com2d->lastRead == 0)
      rb_com2d->lastRead = 16 -1;
  else
      rb_com2d->lastRead--;

  rb_com2d->intr_status |= 1;
	
  gaintr = PAO_STIC(px_info_ptr)->ipdvint;
	
  gaintr |= (0x00010000 |    0x00020000  | 0x00040000 );
  gaintr &= ~(0x00000004 |0x00000400 );
	
  GAO_STIC(px_info_ptr)->ipdvint = gaintr;
}


__inline__

static int aluxtopx(alu)
     int alu;
{
  int retval;
  switch(alu)
    {
    case 		0x0		:
      retval = 	(0x60<<12) ;
      break;
    case 		0x1		:
      retval = 	(0x14<<12) ;
      break;
    case 	0x2		:
      retval = 	(0x15<<12) ;
      break;
    case 		0x3		:
      retval = 	(0x20<<12) ;
      break;
    case 	0x4		:
      retval = (0x16<<12) ;
      break;
    case 		0x5		:
      retval = 	(0x40<<12) ;
      break;
    case 		0x6		:
      retval = 	(0x11<<12) ;
      break;
    case 		0x7		:
      retval = 		(0x0F<<12) ;
      break;
    case 		0x8		:
      retval = 	(0x17<<12) ;
      break;
    case 		0x9		:
      retval = 	(0x10<<12) ;
      break;
    case 	0xa		:
      retval = 	(0x4E<<12) ;
      break;
    case 	0xb		:
      retval = 	(0x0E<<12) ;
      break;
    case 	0xc		:
      retval = (0x2D<<12) ;
      break;
    case 	0xd		:
      retval = 	(0x0D<<12) ;
      break;
    case 		0xe		:
      retval = 	(0x0C<<12) ;
      break;
    case 		0xf		:
      retval = 	(0x6C<<12) ;
      break;
    default:
      fprintf((&_iob[2]) , "unhandled alu\n");
      retval = 	(0x20<<12) ;
    }
  return retval;
}
  
pxpmax1Line(x1, y1, x2, y2, pixel, alu, planemask)
     int x1, y1, x2, y2;
     unsigned long pixel;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return 0 ;
    }
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 10;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 	1  |  	(1<<4)  |   	(1<<10)  |        	(1<<19) ;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |=             	(1)  | 	(1<<8) ;
  nbuf_addr[7] = 4;
  nbuf_addr[8] = 0x7c00400;
  nbuf_addr[9] = 0x7ffffff;
  nbuf_addr[10] = pixel;
  nbuf_addr[11] = (x1 << 19) | (y1 << 3);
  nbuf_addr[12] = (x2 << 19) | (y2 << 3);
  
  ga_send_packet();
}  

static int line_count;
static int *line_addr;

pxpmaxStartLines(pixel, alu, planemask)
     unsigned long pixel;
     int alu;
     int planemask;
{
  int nbuf;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return 0 ;
    }
  line_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  line_addr[0] = 5;
  line_addr[2] = 16;
  line_addr[3] = 	1  |  	(1<<4)  |   	(1<<10)  |        	(1<<19) ;
  planemask &= 0xff;
  line_addr[4] = (planemask << 16) | (planemask << 8) | planemask;
  line_addr[5] = 0;
  line_addr[6] = aluxtopx(alu);
  line_addr[6] |=             	(1)  | 	(1<<8) ;
  line_addr[7] = 4;
  line_addr[8] = 0x7c00400;
  line_addr[9] = 0x7ffffff;
  line_addr[10] = pixel;
  line_count = 0;
}  

pxpmaxAddLine(x1, y1, x2, y2)
     int x1, y1, x2, y2;
{
  line_addr[11+line_count*2] = (x1 << 19) | (y1 << 3);
  line_addr[12+line_count*2] = (x2 << 19) | (y2 << 3);
  line_count++;
  
  if(line_count >= ((1<<8)-1) )
    {
      int planemask, pixel, alu;
      int nbuf;
      
      planemask = line_addr[4];
      alu = line_addr[6];
      pixel = line_addr[10];
      line_addr[1] = 8 + line_count*2;
      line_addr[4] |= (line_count << 24);
      
      ga_send_packet();

      nbuf = rb_com2d->lastWritten;
      if(nbuf >= 16 )
	{
	  ErrorF("Too many packets\n");
	  return 0 ;
	}
      line_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
      line_addr[0] = 5;
      line_addr[2] = 16;
      line_addr[3] = 	1  |  	(1<<4)  |   	(1<<10)  |        	(1<<19) ;
      line_addr[4] = planemask;
      line_addr[5] = 0;
      line_addr[6] = alu;
      line_addr[7] = 4;
      line_addr[8] = 0x7c00400;
      line_addr[9] = 0x7ffffff;
      line_addr[10] = pixel;
      line_count = 0;
    }  
}  

pxpmaxFinishLines()
{
  if(line_count > 0)
    {
      line_addr[1] = 8 + line_count*2;
      line_addr[4] |= (line_count << 24);
      
      ga_send_packet();
    }
}

pxpmaxWideLine(pBox, pixel, alu, planemask)
     BoxPtr pBox;
     unsigned long pixel;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int y2m;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return 0 ;
    }
  
  y2m = pBox->y2 - 1;
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 	1  |  	(1<<4)  |  	(2<<10) ;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |=             	(1) ;
  nbuf_addr[7] = pixel;
  nbuf_addr[8] = ((int)pBox->x1) << 19 | ((y2m + pBox->y1) << 2) | 0x3;
  nbuf_addr[9] = ((pBox->x2-1) << 19) | 0x70000
                 | ((y2m + pBox->y1) << 2) | 0x3;
  nbuf_addr[10] = ((y2m - pBox->y1) << 2) | 0x3;
  
  ga_send_packet();
}

static int bufno = 1;


void
pxpmaxPutSpan(y, xOrigin, xStart, xEnd, psrc, alu, planemask)
     int y;
     int xOrigin;
     int xStart;
     int xEnd;
     int *psrc;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if((span_len >= (		(0x1000)  + 	(		(0x1000)  >> 1) ) ) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (y < 0) || (xEnd > px_info_max_x) || (y >=
     px_info_max_y))
    {
      ErrorF("PutSpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  for(i = 0; i < span_len; i++)
    {
      rb_cntrl->image_buf[((bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) ) )>>2) + i]
	= ((char *)psrc)[xOrigin+i];
    }

  image_off = bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) )  + (2 * 		(0x1000) )  - 12;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 7 ;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |=             	(1)  | 	(0x80000) ;
  nbuf_addr[7] = px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xStart << 19 | (y << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();
}

void
pxpmaxPutBox(yStart, yEnd, xOrigin, xStart, xEnd, psrc, psrcWidth,
	     alu, planemask)
     int yStart;
     int yEnd;
     int xOrigin;
     int xStart;
     int xEnd;
     int *psrc;
     int psrcWidth;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;
  int y;
  int ncom, span_off, tot_span_len;

  span_len = xEnd - xStart;
  if((span_len >= (		(0x1000)  + 	(		(0x1000)  >> 1) ) ) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (yStart < 0) || (xEnd > px_info_max_x)
     || (yEnd > px_info_max_y))
    {
      ErrorF("PutSpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return;
    }
  ncom = 0;
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  span_off = (bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) ) )>>2;
  tot_span_len = 0;
  image_off = bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) )  + (2 * 		(0x1000) )  - 12;
  for(y = yStart; y < yEnd; y++, psrc += psrcWidth)
    {
      for(i = 0; i < span_len; i++)
	rb_cntrl->image_buf[span_off+i] = ((char *)psrc)[xOrigin+i];
      nbuf_addr[7+ncom*4] = px_info_ptr->rb_phys | (image_off + ncom*4*span_len);
      nbuf_addr[8+ncom*4] = 2*span_len*sizeof(int);
      nbuf_addr[9+ncom*4] = xStart << 19 | (y << 3);
      nbuf_addr[10+ncom*4] = 0x0;
      ncom++;
      span_off += span_len;
      tot_span_len += span_len;
      if(y == yEnd - 1 || ncom >= ((1<<8)-1) -1
	 || tot_span_len + span_len >= (		(0x1000)  + 	(		(0x1000)  >> 1) ) >>2)
	{
	  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
	  nbuf_addr[0] = 5;
	  nbuf_addr[1] = 4 + ncom*4;
	  nbuf_addr[2] = 16;
	  nbuf_addr[3] = 7 ;
	  planemask &= 0xff;
	  nbuf_addr[4] = (ncom << 24) | (planemask << 16)
	    | (planemask << 8) | planemask;
	  nbuf_addr[5] = 0;
	  nbuf_addr[6] = aluxtopx(alu);
	  nbuf_addr[6] |=             	(1)  | 	(0x80000) ;
	  ga_send_packet();

	  if(y != yEnd - 1)
	    {
	      bufno ^= 1;
	      nbuf = rb_com2d->lastWritten;
	      if(nbuf >= 16 )
		{
		  ErrorF("Too many packets\n");
		  return;
		}
	      ncom = 0;
	      nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
	      span_off = (bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) ) )>>2;
	      tot_span_len = 0;
	      image_off = bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) )  + (2 * 		(0x1000) )  - 12;
	    }
	}
    }
}

void
pxpmaxGetSpan(y, xOrigin, xStart, xEnd, psrc, planemask)
     int y;
     int xOrigin;
     int xStart;
     int xEnd;
     int *psrc;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if((span_len >= (		(0x1000)  + 	(		(0x1000)  >> 1) ) ) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (y < 0) || (xEnd > px_info_max_x) || (y >=
     px_info_max_y))
    {
      ErrorF("GetSpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  image_off = bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) )  + (2 * 		(0x1000) )  - 12;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 6 ;
 
  planemask = 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = 	(0x40<<12)  |             	(1)  | 	(0x80000) ;
  nbuf_addr[7] = 0x40000000 | px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xStart << 19 | (y << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();

 
  for(i = 0; rb_com2d->intr_status != 0; i++);

  for(i = 0; i < span_len; i++)
    {
      ((unsigned char *)psrc)[xOrigin+i]
	= (rb_cntrl->image_buf[((bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) ) )>>2) + i] & 0xff);
    }
}

void
pxpmaxCopySpan(ysrc, ydst, xOrigin, xStart, xEnd, alu, planemask)
     int ysrc;
     int ydst;
     int xOrigin;
     int xStart;
     int xEnd;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if(xOrigin <= xStart)
    span_len--;

  if((span_len >= (		(0x1000)  + 	(		(0x1000)  >> 1) ) ) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (ysrc < 0) || (ydst < 0) || (xEnd > px_info_max_x)
     || (ysrc >= px_info_max_y) || (ydst >= px_info_max_y))
    {
      ErrorF("CopySpan: bad region\n");
      return;
    }
  
  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 11;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 5  |   	(1<<10)  |        	(1<<19) ;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |=             	(1)  | 	(1<<8)  | 	(0x80000) ;
  if(xStart == xOrigin)
    nbuf_addr[6] |= (1<<20) ;
  nbuf_addr[7] = 3;
  nbuf_addr[8] = 0x7c00400;
  nbuf_addr[9] = 0x7ffffff;
  nbuf_addr[10] = span_len << 3;
  nbuf_addr[11] = xOrigin << 19 | (ysrc << 3);
  nbuf_addr[12] = xStart << 19 | (ydst << 3);
  nbuf_addr[13] = span_len << 3;

  ga_send_packet();
}

void
pxpmaxSlowCopySpan(ysrc, ydst, xOrigin, xStart, xEnd, alu, planemask)
     int ysrc;
     int ydst;
     int xOrigin;
     int xStart;
     int xEnd;
     int alu;
     int planemask;
{
  int *nbuf_addr;
  int nbuf;
  int i;
  int image_off, span_len;

  span_len = xEnd - xStart;
  if((span_len >= (		(0x1000)  + 	(		(0x1000)  >> 1) ) ) || (span_len < 0))
    {
      ErrorF("Span too large or negative\n");
      return;
    }
  if((xStart < 0) || (ysrc < 0) || (ydst < 0) || (xEnd > px_info_max_x)
     || (ysrc >= px_info_max_y) || (ydst >= px_info_max_y))
    {
      ErrorF("SlowCopySpan: bad region\n");
      return;
    }
  
  bufno ^= 1;
  
  image_off = bufno*(		(0x1000)  + 	(		(0x1000)  >> 1) )  + (2 * 		(0x1000) )  - 12;

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 6 ;
  nbuf_addr[4] = (1 << 24) | 0xffffff;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = 	(0x40<<12)  |             	(1)  | 	(0x80000) ;
  nbuf_addr[7] = 0x40000000 | px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xOrigin << 19 | (ysrc << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();

  nbuf = rb_com2d->lastWritten;
  if(nbuf >= 16 )
    {
      ErrorF("Too many packets\n");
      return;
    }
  
  nbuf_addr = &(rb_cntrl->IntrBuf[nbuf][0]);
  nbuf_addr[0] = 5;
  nbuf_addr[1] = 8;
  nbuf_addr[2] = 16;
  nbuf_addr[3] = 7 ;
  planemask &= 0xff;
  nbuf_addr[4] = (1 << 24) | (planemask << 16) | (planemask << 8) | planemask;
  nbuf_addr[5] = 0;
  nbuf_addr[6] = aluxtopx(alu);
  nbuf_addr[6] |=             	(1)  | 	(0x80000) ;
  nbuf_addr[7] = px_info_ptr->rb_phys | image_off;
  nbuf_addr[8] = 2*span_len*sizeof(int);
  nbuf_addr[9] = xStart << 19 | (ydst << 3);
  nbuf_addr[10] = 0x0;
  
  ga_send_packet();
}
